import discord

from v6d2ctx.context import Context, Implicit, Explicit
from v6d2ctx.handle_command import handle_command


async def handle_args(message: discord.Message, args: list[str]):
    match args:
        case []:
            return
        case [command_name, *command_args]:
            ctx = Context(message)
            try:
                await handle_command(ctx, command_name, command_args)
            except Implicit:
                pass
            except Explicit as e:
                await ctx.reply(e.msg)
