import asyncio
from typing import Hashable

from v6d2ctx.context import Explicit

locks: dict[Hashable, asyncio.Lock] = {}


def lock_for(key: Hashable, error_message: str) -> asyncio.Lock:
    if key is None:
        raise Explicit(error_message)
    if key in locks:
        return locks[key]
    else:
        return locks.setdefault(key, asyncio.Lock())
